﻿#region WatiN Copyright (C) 2006-2009 Jeroen van Menen

//Copyright 2006-2009 Jeroen van Menen
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

#endregion Copyright

using System;
using System.Windows.Forms;
using mshtml;
using WatiN.Core.Native;
using WatiN.Core.Native.InternetExplorer;
using WatiN.Core.Native.Windows;

namespace WatiN.MsHtmlBrowser
{
    public class MsHtmlNativeBrowser : INativeBrowser
    {
        private IEDocument _ieDocument;

        public void NavigateTo(Uri url)
        {
            var htmlDoc = new HTMLDocument();
            var ips = (IPersistStreamInit)htmlDoc;
            ips.InitNew();

            var htmlDoc2 = htmlDoc.createDocumentFromUrl(url.AbsoluteUri, "null");

            while (htmlDoc2.readyState != "complete")
            {
                //This is also a important part, without this DoEvents() appz hangs on to the “loading”
                Application.DoEvents();
            }
            _ieDocument = new IEDocument(htmlDoc2);
        }

        public INativeDocument NativeDocument
        {
            get { return _ieDocument; }
        }

        public void NavigateToNoWait(Uri url)
        {
            throw new NotImplementedException();
        }

        public bool GoBack()
        {
            throw new NotImplementedException();
        }

        public bool GoForward()
        {
            throw new NotImplementedException();
        }

        public void Reopen()
        {
            throw new NotImplementedException();
        }

        public void Refresh()
        {
            throw new NotImplementedException();
        }

        public IntPtr hWnd
        {
            get { throw new NotImplementedException(); }
        }
    }
}
